# [auto-generated by add-features.py]
# DO NOT MODIFY THIS FILE. MODIFY conftest_general.py INSTEAD AND RUN add-features.py TO RECREATE THIS ONE.
"""Pytest configuration file"""

import grpc
import pytest
from _pytest.python import Class, Function

from sila2_interop_communication_tester import __version__
from sila2_interop_communication_tester.grpc_stubs.SiLABinaryTransfer_pb2_grpc import (
    BinaryDownloadStub,
    BinaryUploadStub,
)
from sila2_interop_communication_tester.helpers.utils import normalize_docstring

# is set in __main__.py
CHANNEL: grpc.Channel = grpc.insecure_channel("127.0.0.1:50052")


@pytest.fixture(scope="session")
def channel() -> grpc.Channel:
    return CHANNEL  # noqa: F821


@pytest.fixture(scope="session")
def binary_download_stub(channel) -> BinaryDownloadStub:
    return BinaryDownloadStub(channel)


@pytest.fixture(scope="session")
def binary_upload_stub(channel) -> BinaryUploadStub:
    return BinaryUploadStub(channel)


@pytest.fixture(scope="session", autouse=True)
def log_global_env_facts(record_testsuite_property):
    record_testsuite_property("version", __version__)


def pytest_collection_modifyitems(session, config, items: list[Function]):
    """Modify test functions"""
    for item in items:  # items: test functions
        if isinstance(item.parent, Class):
            parent = item.parent.newinstance()
        else:
            parent = item.parent.obj
        test_docstring = getattr(parent, item.originalname).__doc__

        if test_docstring:
            item.user_properties.append(("doc", normalize_docstring(test_docstring)))


# [auto-generated test fixtures]
# fixtures creating stubs for all available SiLA features
from pytest import fixture

from ..grpc_stubs.AuthenticationService_pb2_grpc import AuthenticationServiceStub
from ..grpc_stubs.AuthenticationTest_pb2_grpc import AuthenticationTestStub
from ..grpc_stubs.AuthorizationService_pb2_grpc import AuthorizationServiceStub
from ..grpc_stubs.BinaryTransferTest_pb2_grpc import BinaryTransferTestStub
from ..grpc_stubs.ErrorHandlingTest_pb2_grpc import ErrorHandlingTestStub
from ..grpc_stubs.MetadataConsumerTest_pb2_grpc import MetadataConsumerTestStub
from ..grpc_stubs.MetadataProvider_pb2_grpc import MetadataProviderStub
from ..grpc_stubs.ObservableCommandTest_pb2_grpc import ObservableCommandTestStub
from ..grpc_stubs.ObservablePropertyTest_pb2_grpc import ObservablePropertyTestStub
from ..grpc_stubs.SiLAService_pb2_grpc import SiLAServiceStub
from ..grpc_stubs.UnobservableCommandTest_pb2_grpc import UnobservableCommandTestStub
from ..grpc_stubs.UnobservablePropertyTest_pb2_grpc import UnobservablePropertyTestStub


@fixture(scope="session")
def authenticationservice_stub(channel) -> AuthenticationServiceStub:
    return AuthenticationServiceStub(channel)


@fixture(scope="session")
def authenticationtest_stub(channel) -> AuthenticationTestStub:
    return AuthenticationTestStub(channel)


@fixture(scope="session")
def authorizationservice_stub(channel) -> AuthorizationServiceStub:
    return AuthorizationServiceStub(channel)


@fixture(scope="session")
def binarytransfertest_stub(channel) -> BinaryTransferTestStub:
    return BinaryTransferTestStub(channel)


@fixture(scope="session")
def errorhandlingtest_stub(channel) -> ErrorHandlingTestStub:
    return ErrorHandlingTestStub(channel)


@fixture(scope="session")
def metadataconsumertest_stub(channel) -> MetadataConsumerTestStub:
    return MetadataConsumerTestStub(channel)


@fixture(scope="session")
def metadataprovider_stub(channel) -> MetadataProviderStub:
    return MetadataProviderStub(channel)


@fixture(scope="session")
def observablecommandtest_stub(channel) -> ObservableCommandTestStub:
    return ObservableCommandTestStub(channel)


@fixture(scope="session")
def observablepropertytest_stub(channel) -> ObservablePropertyTestStub:
    return ObservablePropertyTestStub(channel)


@fixture(scope="session")
def silaservice_stub(channel) -> SiLAServiceStub:
    return SiLAServiceStub(channel)


@fixture(scope="session")
def unobservablecommandtest_stub(channel) -> UnobservableCommandTestStub:
    return UnobservableCommandTestStub(channel)


@fixture(scope="session")
def unobservablepropertytest_stub(channel) -> UnobservablePropertyTestStub:
    return UnobservablePropertyTestStub(channel)
